#include <iostream>
#include <queue>

using namespace std;

const int maxn = 52;
const int inf = 2000000000;

int n, a[maxn];
int u[maxn][maxn], f[maxn][maxn];
int fr[maxn], vis[maxn];
queue<int> q;

int main()
{
   freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
   
   int i, j, k;
   
   cin >> n;
   memset(u, 0, sizeof(u));
   for (i = 0; i < n; i++) {
      cin >> a[i];
      if (a[i] == 1) u[0][i+1] = inf;
      if (a[i] == 2) u[i+1][n+1] = inf;
   }
   for (i = 0; i < n; i++)
      for (j = 0; j < n; j++)
         cin >> u[i+1][j+1];
         
   while (1) {      
      memset(vis, 0, sizeof(vis));
      while (!q.empty()) q.pop();
      q.push(0);
      while (!q.empty()) {
         k = q.front(); q.pop(); 
         for (i = 0; i <= n+1; i++)
            if (!vis[i] && u[k][i]-f[k][i] > 0) {
               vis[i] = 1; fr[i] = k; q.push(i);
            }
      }
      if (!vis[n+1]) break;
      int flow = inf;
      for (k = n+1; k; k = fr[k]) flow = min(flow, u[fr[k]][k]-f[fr[k]][k]);
      for (k = n+1; k; k = fr[k]) {f[fr[k]][k] += flow; f[k][fr[k]] -= flow;}
   }
   
   int ans = 0;
   for (i = 1; i <= n; i++) ans += f[0][i];
   
   cout << ans;

   fclose(stdin); fclose(stdout);
   return 0;   
}
