#include <algorithm>
#include <iostream>
#include <sstream>

using namespace std;

const int maxn = 50;

int n;
int a[maxn][maxn];
int vis[maxn];

int main(int argc, char* argv[])
{
   int i, j;
   istringstream s_n(argv[1]);
   istringstream s_minval(argv[2]);
   istringstream s_maxval(argv[3]);
   istringstream s_seed(argv[4]);
   
   int minval, maxval;
   int seed;
   s_n >> n;
   s_minval >> minval;
   s_maxval >> maxval;
   s_seed >> seed;
   srand(seed);
   
   int s = 0, t = n-1;
   cout << n << endl;
   for (i = 0; i < n; i++) {
      if (i == s) cout << 1;
      else if (i == t) cout << 2;
      else cout << 0;
      cout << " ";
   }
   cout << endl;
   
   for (i = 0; i < n; i++)
      for (j = 0; j < n; j++)
         if (j > i) a[i][j] = minval;
   
   int mx = minval;
   int num = 0;
   while (mx < maxval && num < 5*n) {
      int u = s;
      int c = 1 + rand()%(maxval-mx);
      memset(vis, 0, sizeof(vis));
      vis[s] = 1;
      while (u != t) {
         int v;
         while (1) {
            v = rand() % n;
            if (!vis[v]) break;
         }
         vis[v] = 1;
         a[u][v] += c;
         if (a[u][v] > mx) mx = a[u][v];
         u = v;               
      }
      num++;      
   }
   
   for (i = 0; i < n; i++) {
      for (j = 0; j < n; j++) {
         cout << a[i][j] << " ";
      }
      cout << endl;
   }   
   
   return 0;
}