#include "easygen.h"
#include "easygen.cpp"

#include <algorithm>
#include <iostream>

using namespace std;

int seq[50];

int main(int argc, char* argv[])
{
   int i, j;
   int s[3];

   try {
      testInfo a(argc, argv);
      int n = a.getIntParam("N");
      memset(s, 0, sizeof(s));
      for (i = 0; i < n; i++) {
         int k = genRandInt(0, 5);
         if (k > 2) k = 0;
         s[k]++;
         seq[i] = k;
      }
      if (!s[1]) {
         s[seq[0]]--;
         seq[0] = 1;
      }
      if (!s[2]) {
         seq[n-1] = 2;
      }
      for (i = 0; i < n; i++) a["a"][i+1]["a"] = seq[i];
      double p = a.getFloatParam("p");
      for (int i = 0; i < n; i++) 
         for (int j = 0; j < n; j++) {
            int x;
            if (i == j) x = 0;
            else x = genRandFloat(0, 1, 2) <= p ? x = genRandInt(1, 1000000) : 0;
            a["u"][i+1]["u"][j+1]["u"] = x;
         }
   } catch (genError a) {
      cout << a.err();
   }
   return 0;
}